/*
 * (C) Copyright 2007 Media Lab. <linux@mlb.co.jp>
 *
 * CQpub Interface LANC 
 */
#ifndef IFNIC_H
#define IFNIC_H

#define IFNIC_DEVID		(0x00)
#define   IFNIC_DEVID_VALUE	(0x434e414c)
#define IFNIC_REV		(0x04)

#define IFNIC_INTSTAT		(0x10)
#define IFNIC_INTMASK		(0x14)
#define  INT_LINKSTATUS		(1<<31)
#define  INT_TXERR		(1<<17)
#define  INT_TXDONE		(1<<16)
#define  INT_RXERR		(1<<1)
#define  INT_RXDONE		(1<<0)

#define IFNIC_MIISTATUS		(0x20)
#define  DUPLEX_CHANGE		(1<<18)
#define  SPEED_CHANGE		(1<<17)
#define  LINK_CHANGE		(1<<16)
#define  DUPLEX_STATUS		(1<<2)
#define  SPEED_STATUS		(1<<1)
#define  LINK_STATUS		(1<<0)


#define IFNIC_MAC_ADDR		(0x28)
#define  MAC_WRITE		(1<<31)
#define  MAC_ADDR(a)		((a)<<16)
#define  MAC_DATA(d)		((d)&0xFF)

#define IFNIC_MAC_ROMADDR	(0x10)
#define IFNIC_ROM		(0x2c)
#define  ROM_BUSY	  	(1<<31)
#define  ROM_READ     		(1<<30)
#define  ROM_ADDR(a)		(((a)&0xFF)<<16)
#define  ROM_WRITEDATA(d)	(((d)&0xFF)<<8)
#define  ROM_READDATA(d)	((d)&0xFF)


#define IFNIC_RXCFG   		(0x40)
#define  RXRST            	(1<<31)
#define  NO_BROADCAST          	(1<<2)
#define  PROMISC            	(1<<1)
#define  RXERROR            	(1<<0)
#define IFNIC_RXBUF_STATUS 	(0x44)
#define  RXBUF_VALID         	(1<<31)
#define  RXBUF_FREE            	(1<<31)
#define  RXBUF_OF        	(1<<30)
#define  RXBUF_PHYERR         	(1<<28)
#define  RXBUF_FERR2           	(1<<27)
#define  RXBUF_FERR1           	(1<<26)
#define  RXBUF_FERR0           	(1<<25)
#define  RXBUF_CRCERR          	(1<<24)
#define  RXBUF_SIZE_MASK       	((1<<11)-1)

#define IFNIC_STAT_LOST		(0x50)
#define IFNIC_STAT_PHYERR	(0x54)
#define IFNIC_STAT_FRAMEERR	(0x58)
#define IFNIC_STAT_CRCERR	(0x5C)

#define IFNIC_TXCFG   		(0x60)
#define  TXRST            	(1<<31)
#define IFNIC_TXBUF_STATUS	(0x64)
#define  TXBUF_BUSY           	(1<<31)
#define  TXBUF_ERR	       	(1<<30)
#define  TXBUF_SIZE_MASK       	((1<<11)-1)

#define IFNIC_COLLISION		(0x68)
#define IFNIC_STAT_COLLISION	(0x70)

#define IFNIC_MIIPHY		(0x80)
#define  MIIPHY_BUSY		(1<<31)
#define  MIIPHY_READ		(1<<30)
#define  MIIPHY_ADDR(a)		(((a)&0x1F)<<8)
#define  MIIPHY_REG(d)		((d)&0xF)

#define IFNIC_MIIPHYDATA	(0x84)
#define  MIIPHY_READDATA(a)	(((a)>>16)&0xFFFF)
#define  MIIPHY_WRITEDATA(a)	((a)&0xFFFF)

#define IFNIC_TXBUF   		(0x4000)
#define IFNIC_RXBUF   		(0x8000)
 
#endif /* IFNIC_H */
