/*
 * (C) Copyright 2007
 * Media Lab. Inc.,
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/*
 * Config header file for TANBAC TB0287 miniITX board with
 * TB0229 cpu module(VR4131-DIMM).
 */

#ifndef __CONFIG_H
#define __CONFIG_H

#define CONFIG_MIPS32		1	/* MIPS 4Kc CPU core	*/
#define CONFIG_TB0229		1	/* Vr4131-DIMM		*/
#define CFG_BLANCA		1	/* CQ Pub Blanca	*/
#define CONFIG_ENV_IDE_MAXBUS		/* allow ide_maxbus environment */

#ifndef CPU_CLOCK_RATE
#define CPU_CLOCK_RATE	200000000	/* 200 MHz clock for the MIPS core */
#endif
/* #define CPU_TCLOCK_RATE 16588800 */	/* 16.5888 MHz for TClock */
#define CPU_TCLOCK_RATE 24883200	/* 24.8832 MHz for TClock */

#define CONFIG_CONS_INDEX	1
#define CONFIG_BOOTDELAY	5	/* autoboot after 5 seconds	*/

#define CONFIG_BAUDRATE		115200
#define CFG_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200 }

#define CONFIG_RTC_VR41XX

#define CONFIG_TIMESTAMP		/* Print image info with timestamp */

#define CONFIG_JFFS2_CMDLINE
#define MTDIDS_DEFAULT		"nor0=physmap-flash.0"
#define MTDPARTS_DEFAULT	"mtdparts=physmap-flash.0:"\
		"0x40000(uboot),0x20000(ubootenv),0x300000(root),-(conf)"
#define	CONFIG_BOOTARGS		"bootargs=root=/dev/mtdblock2 ro console=ttyVR0,115200"
#define CONFIG_BOOTFILE		"uImage"


#define CFG_HUSH_PARSER 

#ifdef CFG_HUSH_PARSER
#define CONFIG_PREBOOT	"echo \'\n"					\
	"Type \"boot\"		for default way\n"			\
	"Type \"run cram\"		to boot from flash\n"		\
	"Type \"run disk\"		to boot from CF\n"		\
	"Type \"run nfs\"		to boot from NFS\n"		\
	"Type \"run initrd\"	to boot with initrd\n\'"

#define CONFIG_AUTO_COMPLETE	1
#define CFG_PROMPT_HUSH_PS2  "> "
#define CONFIG_EXTRA_ENV_SETTINGS					\
	"mtdids=" MTDIDS_DEFAULT	"\0"				\
	"mtdparts=" MTDPARTS_DEFAULT	"\0"				\
	"partition=nor0,2\0"						\
	"autoload=no\0"							\
	"netretry=once\0"						\
	"verify=no\0"							\
	"uboot_start=BFC00000\0"					\
	"uboot_size=40000\0"						\
	"env_start=BFC40000\0"						\
	"env_size=20000\0"						\
	"cram_start=BFC60000\0"						\
	"cram_size=300000\0"						\
	"conf_start=BFF60000\0"						\
	"conf_size=A0000\0"						\
	"ubootfile=u-boot.bin\0"					\
	"initrdfile=ramImage\0"						\
	"cramfile=rom.img\0"						\
	"cramargs=setenv bootargs root=/dev/mtdblock2 ro\0"		\
	"diskargs=setenv bootargs root=/dev/hda1 ro\0"			\
	"nfsargs=setenv bootargs root=/dev/nfs "			\
		"ip=$ipaddr:$serverip:$gatewayip:$netmask::eth0: "	\
		"nfsroot=$nfsroot ro\0"					\
	"userargs=setenv bootargs $bootargs "				\
		"console=ttyVR0,$baudrate $mtdparts\0"			\
	"ext2dev=0\0"							\
	"fatdev=0\0"							\
	"load_kernel_cram=fsload $bootfile\0"				\
	"load_kernel_ext2=ext2load ide $ext2dev 80400000 $bootfile\0"	\
	"load_kernel_fat=fatload ide $fatdev 80400000 $bootfile\0"	\
	"load_kernel_tftp=run checkipaddr&&tftp 80400000 $bootfile\0"	\
	"load_kernel_nfs=run checknfsbase checkipaddr&&"		\
			"nfs 80400000 $nfsbase$bootfile\0"		\
	"load_kernel_serial=echo \"Please send $bootfile\";"		\
			"loady 80400000\0"				\
	"load_method=nfs\0"						\
	"load_kernel=run load_kernel_$load_method &&iminfo 80400000\0"	\
	"load_initrd_cram=fsload $initrdfile\0"				\
	"load_initrd_ext2=ext2load ide $ext2dev 80600000 $initrdfile\0"	\
	"load_initrd_fat=fatload ide $fatdev 80600000 $initrdfile\0"	\
	"load_initrd_tftp=run checkipaddr&&tftp 80600000 $initrdfile\0"	\
	"load_initrd_nfs=run checknfsbase checkipaddr&&"		\
			"nfs 80600000 $nfsbase$initrdfile\0"		\
	"load_initrd_serial=echo \"Please send $initrdfile\";"		\
			"loady 80600000\0"				\
	"load_initrd=run load_initrd_$load_method &&iminfo 80600000\0"	\
	"load_cram_ext2=ext2load ide $ext2dev 80400000 $cramfile\0"	\
	"load_cram_fat=fatload ide $fatdev 80400000 $cramfile\0"	\
	"load_cram_tftp=run checkipaddr&&tftp 80400000 $cramfile\0"	\
	"load_cram_nfs=run checknfsbase checkipaddr&&"			\
			"nfs 80400000 $nfsbase$cramfile\0"		\
	"load_cram_serial=echo \"Please send $cramfile\";"		\
			"loady 80400000\0"				\
	"update_method=nfs\0"						\
	"load_cram=run load_cram_$update_method\0"			\
	"load_uboot_ext2=ext2load ide $ext2dev 80400000 $ubootfile\0"	\
	"load_uboot_fat=fatload ide $fatdev 80400000 $ubootfile\0"	\
	"load_uboot_tftp=run checkipaddr&&tftp 80400000 $ubootfile\0"	\
	"load_uboot_nfs=run checknfsbase checkipaddr&&"			\
			"nfs 80400000 $nfsbase$ubootfile\0"		\
	"load_uboot_serial=echo \"Please send $ubootfile\";"		\
			"loady 80400000\0"				\
	"load_uboot=run load_uboot_$update_method\0"			\
	"cram=if run load_kernel_cram; then run cramargs userargs;"	\
		"bootm;fi\0"						\
	"disk=ide reset&&if run load_kernel_ext2;then run diskargs userargs;"	\
		"bootm;fi\0"						\
	"nfs=if run load_kernel_nfs;then run nfsargs userargs &&"	\
		"bootm;fi\0"						\
	"initrd=if run load_kernel load_initrd; then "			\
		"run nfsargs userargs;bootm 80400000 80600000;"		\
		"fi\0"							\
	"uboot=if run load_uboot; then go 80400000; fi\0"		\
	"checknfsbase=if test x$nfsbase = x;then "			\
		"echo \"*** ERROR: \'nfsbase\' not set\";test a = b;"	\
		"else test 1 = 1;fi\0"					\
	"checkipaddr=if test x$ipaddr = x;then dhcp;"			\
		"else test 1 = 1;fi\0"					\
	"init_uboot=protect off $uboot_start +$uboot_size;"		\
		"echo erasing uboot area;"				\
		"erase $uboot_start +$uboot_size\0"			\
	"init_cram=protect off $cram_start +$cram_size;"		\
		"echo erasing cram area;"				\
		"erase $cram_start +$cram_size\0"			\
	"init_env=protect off $env_start +$env_size;"			\
		"echo erasing env area;"				\
		"erase $env_start +$env_size\0"				\
	"init_conf=protect off $conf_start $conf_size;"			\
		"echo erasing conf area;"				\
		"erase $conf_start +$conf_size\0"				\
	"verify_uboot=if run load_uboot; then "				\
		"echo verifying image;"					\
		"cmp.b 80400000 $uboot_start $filesize;"		\
		"else test a = b;fi\0"					\
	"verify_cram=if run load_cram; then "				\
		"echo verifying image;"					\
		"cmp.b 80400000 $cram_start $filesize;"			\
		"else test a = b;fi\0"					\
	"update_uboot=if run load_uboot&&itest $filesize <= $uboot_size;"\
 		"then run init_uboot;"					\
		"cp.b 80400000 $uboot_start $filesize;"			\
		"run verify_uboot && reset;"				\
		"fi\0"							\
	"update_cram=if run load_cram&&itest $filesize <= $cram_size;"	\
		"then run init_cram;"					\
		"cp.b 80400000 $cram_start $filesize;"			\
		"run verify_cram;"					\
		"fi\0"							\
	"bootorder=disk nfs cram\0"					\
	"tryboot=for i in $bootorder; do run $i; done\0"		\
	""

#define CONFIG_BOOTCOMMAND	"run tryboot"
#else
#define CONFIG_PREBOOT	"echo;"						\
	"echo 'Type \"boot\"		for default way';"		\
	"echo 'Type \"run cram\"		to boot from flash';"	\
	"echo 'Type \"run disk\"		to boot from CF';"\
	"echo 'Type \"run nfs\"		to boot from NFS';"		\
	"echo 'Type \"run initrd\"	to boot with initrd';"		\
	"echo"

#define CONFIG_EXTRA_ENV_SETTINGS					\
	"mtdids=" MTDIDS_DEFAULT	"\0"				\
	"mtdparts=" MTDPARTS_DEFAULT	"\0"				\
	"partition=nor0,2\0"						\
	"autoload=no\0"							\
	"netretry=once\0"						\
	"verify=no\0"							\
	"uboot_start=BFC00000\0"					\
	"uboot_size=40000\0"					\
	"env_start=BFC40000\0"						\
	"env_size=20000\0"						\
	"cram_start=BFC60000\0"						\
	"cram_size=300000\0"						\
	"conf_start=BFF60000\0"						\
	"conf_size=A0000\0"						\
	"ubootfile=u-boot.bin\0"					\
	"initrdfile=ramImage\0"						\
	"cramfile=rom.img\0"						\
	"cramargs=setenv bootargs root=/dev/mtdblock2 ro\0"		\
	"diskargs=setenv bootargs root=/dev/hda1 ro\0"			\
	"nfsargs=setenv bootargs root=/dev/nfs "			\
		"ip=$(ipaddr):$(serverip):$(gatewayip):$(netmask)::eth0: "\
		"nfsroot=$(nfsroot) ro\0"				\
	"userargs=setenv bootargs $(bootargs) "				\
		"console=ttyVR0,$(baudrate) $(mtdparts)\0"	\
	"nfsbase=192.168.3.91:/usr/src/mldbox/\0"			\
	"nfsroot=192.168.3.91:/usr/src/mldbox/rom\0"			\
	"ext2dev=0\0"							\
	"fatdev=0\0"							\
	"load_kernel_cram=fsload $(bootfile)\0"				\
	"load_kernel_ext2=ext2load ide $(ext2dev) 80400000 $(bootfile)\0"\
	"load_kernel_fat=fatload ide $(fatdev) 80400000 $(bootfile)\0"	\
	"load_kernel_tftp=tftp 80400000 $(bootfile)\0"			\
	"load_kernel_nfs=nfs 80400000 $(nfsbase)$(bootfile)\0"		\
	"load_method=nfs\0"						\
	"load_kernel=run load_kernel_$(load_method); iminfo 80400000\0"	\
	"load_initrd_cram=fsload $(initrdfile)\0"			\
	"load_initrd_ext2=ext2load ide $(ext2dev) 80600000 $(initrdfile)\0"	\
	"load_initrd_fat=fatload ide $(fatdev) 80600000 $(initrdfile)\0"\
	"load_initrd_tftp=tftp 80600000 $(initrdfile)\0"		\
	"load_initrd_nfs=nfs 80600000 $(nfsbase)$(initrdfile)\0"	\
	"load_initrd=run load_initrd_$(load_method);iminfo 80600000\0"	\
	"load_cram_ext2=ext2load ide $(ext2dev) 80400000 $(cramfile)\0"	\
	"load_cram_fat=fatload ide $(fatdev) 80400000 $(cramfile)\0"	\
	"load_cram_tftp=tftp 80400000 $(cramfile)\0"			\
	"load_cram_nfs=nfs 80400000 $(nfsbase)$(cramfile)\0"		\
	"update_method=nfs\0"						\
	"load_cram=run load_cram_$(update_method)\0"			\
	"load_uboot_ext2=ext2load ide $(ext2dev) 80400000 $(ubootfile)\0"\
	"load_uboot_fat=fatload ide $(fatdev) 80400000 $(ubootfile)\0"	\
	"load_uboot_tftp=tftp 80400000 $(ubootfile)\0"			\
	"load_uboot_nfs=nfs 80400000 $(nfsbase)$(ubootfile)\0"		\
	"load_uboot=run load_uboot_$(update_method)\0"			\
	"cram=run load_kernel_cram cramargs userargs; bootm\0"		\
	"disk=ide reset;run load_kernel_ext2 diskargs userargs; bootm\0"\
	"nfs=run load_kernel_nfs nfsargs userargs;bootm\0"		\
	"initrd=run load_kernel load_initrd nfsargs userargs;"		\
		"bootm 80400000 80600000\0"				\
	"uboot=run load_uboot; go 80400000\0"				\
	"init_uboot=protect off $(uboot_start) +$(uboot_size);"		\
		"echo erasing uboot area;"				\
		"erase $(uboot_start) +$(uboot_size)\0"			\
	"init_cram=protect off $(cram_start) +$(cram_size);"		\
		"echo erasing cram area;"				\
		"erase $(cram_start) +$(cram_size)\0"			\
	"init_env=protect off $(env_start) +$(env_size);"		\
		"echo erasing env area;"				\
		"erase $(env_start) +$(env_size)\0"			\
	"verify_uboot=run load_uboot;echo verifying;"			\
		"cmp.b 80400000 $(uboot_start) $(filesize)\0"		\
	"verify_cram=run load_cram;"					\
		"echo verifying;"					\
		"cmp.b 80400000 $(cram_start) $(filesize)\0"		\
	"update_uboot=run load_uboot init_uboot;"			\
		"cp.b 80400000 $(uboot_start) $(filesize);"		\
		"run verify_uboot\0"					\
	"update_cram=run load_cram init_cram;"				\
		"cp.b 80400000 $(cram_start) $(filesize);"		\
		"run verify_cram\0"					\
	""
#define CONFIG_BOOTCOMMAND	"run nfs"
#endif

#define CONFIG_JFFS2_DEV	"nor0"
#define CONFIG_JFFS2_PART_OFFSET	0x60000
#define CONFIG_JFFS2_PART_SIZE	(0xC0000000 - 0xBFC60000)
#define CONFIG_COMMANDS		(CONFIG_CMD_DFL | \
				 CFG_CMD_ASKENV | \
				 CFG_CMD_JFFS2	| \
				 CFG_CMD_DHCP	| \
				 CFG_CMD_PING	| \
				 CFG_CMD_MII	| \
				 CFG_CMD_PCI	| \
				 CFG_CMD_IDE	| \
				 CFG_CMD_DATE	| \
				 CFG_CMD_SNTP	| \
				/* CFG_CMD_REISER | */ \
				 CFG_CMD_EXT2	| \
				 CFG_CMD_FAT	| \
				 CFG_CMD_ELF	)

#include <cmd_confdefs.h>

/*
 * Miscellaneous configurable options
 */
#define CFG_LONGHELP				/* undef to save memory	     */
#define CFG_PROMPT		"# "		/* Monitor Command Prompt    */
#define CFG_CBSIZE		512		/* Console I/O Buffer Size   */
#define CFG_PBSIZE (CFG_CBSIZE+sizeof(CFG_PROMPT)+16)  /* Print Buffer Size */
#define CFG_MAXARGS		16		/* max number of command args*/

#define CFG_MALLOC_LEN		128*1024

#define CFG_BOOTPARAMS_LEN	128*1024

#define CFG_HZ			(CPU_TCLOCK_RATE/4)

#define CFG_SDRAM_BASE		0x80000000

#define CFG_LOAD_ADDR		0x80400000	/* default load address */

#define CFG_MEMTEST_START	0x80000000
#define CFG_MEMTEST_END		0x80800000

/*-----------------------------------------------------------------------
 * FLASH and environment organization
 */
#define CFG_MAX_FLASH_BANKS	1	/* max number of memory banks */
#define CFG_MAX_FLASH_SECT	(128)	/* max number of sectors on one chip */

#define PHYS_FLASH_1		0xbfc00000 /* Flash Bank #1 */

#if (CONFIG_COMMANDS & CFG_CMD_JFFS2)
#define __SIZE_TYPE__		unsigned int
/* #define CFG_JFFS_CUSTOM_PART	1 */

#ifndef CFG_JFFS_CUSTOM_PART
#define CFG_JFFS2_FIRST_BANK	0
#define CFG_JFFS2_NUM_BANKS	1
#define CFG_JFFS2_FIRST_SECTOR	6	/* 0xbfc60000 */
#endif
#endif


/* The following #defines are needed to get flash environment right */
#define CFG_MONITOR_BASE	TEXT_BASE
#define CFG_MONITOR_LEN		(256 << 10)

#define CFG_INIT_SP_OFFSET	0x400000

#define CFG_FLASH_BASE		PHYS_FLASH_1

/* timeout values are in ticks */
#define CFG_FLASH_ERASE_TOUT	(20 * CFG_HZ) /* Timeout for Flash Erase */
#define CFG_FLASH_WRITE_TOUT	(2 * CFG_HZ) /* Timeout for Flash Write */

#define CFG_ENV_IS_IN_FLASH	1

/* Address and size of Primary Environment Sector	*/
#define CFG_ENV_ADDR		0xBFC40000
#define CFG_ENV_SIZE		0x20000

#define CFG_DIRECT_FLASH_TFTP

#define CONFIG_NR_DRAM_BANKS	1

/*-----------------------------------------------------------------------
 * Cache Configuration
 */
#define CFG_DCACHE_SIZE		16384
#define CFG_ICACHE_SIZE		16384
#define CFG_CACHELINE_SIZE	16

/*-----------------------------------------------------------------------
 * Serial Configuration
 */
#define CFG_NS16550
#define CFG_NS16550_SERIAL
#define CFG_NS16550_REG_SIZE	 1
#define CFG_NS16550_CLK		 18432000
#define CFG_NS16550_COM1	 0xaf000800

/*-----------------------------------------------------------------------
 * PCI stuff
 */
#define CONFIG_PCI
#define CONFIG_PCI_PNP
#define CFG_UDELAY_AFTER_PCI_RESET	1000
#define CONFIG_NET_MULTI
#define CONFIG_RTL8169
#define CONFIG_IFNIC_PCI
#define CFG_RX_ETH_BUFFER	8

#define CONFIG_ATAPI		1
#define CONFIG_DOS_PARTITION	1
/* #define CONFIG_ISO_PARTITION	1 */
#define CFG_IDE_MAXBUS		1
#define CFG_IDE_MAXDEVICE	(CFG_IDE_MAXBUS*2)
#define CFG_ATA_BASE_ADDR	0x00000000
#define CFG_ATA_IDE0_OFFSET	0
#define CFG_ATA_DATA_OFFSET	0xC0
#define	CFG_ATA_REG_OFFSET	CFG_ATA_DATA_OFFSET
#define CFG_ATA_ALT_OFFSET	0xE0
#define CFG_ATA_STRIDE		4
#define CONFIG_IDE_PREINIT

#endif	/* __CONFIG_H */
