/*
 * (C) Copyright 2003-2005
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * (C) Copyright 2004
 * Metrowerks, Author: Bernhard Kuhn <bkuhn@metrowerks.com> [BK]
 *
 * BK: added CFG_ENV_SAVESIZE option
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 *
 * Midified 2006.10.25  Media Lab., Inc  <linux@mlb.co.jp>
 *   Changed for TANBAC TB0287+MPC5200DIMM
 *   2007.08.29 rename CONFIG_TB0XXX_IDE to CONFIG_ENV_IDE_MAXBUS
 * Midified 2007.06.01  Forks Inc  <info@yaya.forks.co.jp>
 *   added for CONFIG_ZERO_BOOTDELAY_CHECK define.
 *   added for CONFIG_TB0XXX_IDE define. (allow ide_maxbus enviroment)
 */

#ifndef __CONFIG_H
#define __CONFIG_H

/*
 * High Level Configuration Options
 * (easy to change)
 */

#define CONFIG_MPC5200			/* MPC5200 CPU */
#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
#define CONFIG_ENV_IDE_MAXBUS		/* allow ide_maxbus environment */
#define CFG_BLANCA	                /* CQ Pub blanca board */

#define CFG_MPC5XXX_CLKIN	33000000 /* ... running at 33.000000MHz */

#define BOOTFLAG_COLD		0x01	/* Normal Power-On: Boot from FLASH  */
#define BOOTFLAG_WARM		0x02	/* Software reboot	     */

#define CFG_CACHELINE_SIZE	32	/* For MPC5xxx CPUs */
#if (CONFIG_COMMANDS & CFG_CMD_KGDB)
#  define CFG_CACHELINE_SHIFT	5	/* log base 2 of the above value */
#endif

#define CONFIG_BOOTDELAY	5	/* autoboot after 5 seconds	*/
#define CONFIG_ZERO_BOOTDELAY_CHECK     /* check for keypress on bootdelay==0 */

/*
 * Serial console configuration
 */
#define CONFIG_PSC_CONSOLE	1	/* console is on PSC1 */
#define CONFIG_BAUDRATE		115200	/* ... at 115200 bps */
#define CFG_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200, 230400 }

#define CONFIG_RTC_MPC5200

#define CONFIG_TIMESTAMP		/* Print image info with timestamp */

#define CONFIG_JFFS2_CMDLINE
#define MTDIDS_DEFAULT		"nor0=physmap-flash.0"
#define MTDPARTS_DEFAULT	"mtdparts=physmap-flash.0:"		\
		"0x200000(kernel),0x500000(user),0x40000(uboot),0x20000(ubootenv),-(conf)"

#define	CONFIG_BOOTARGS		"root=/dev/mtdblock1 ro console=ttyPSC0,115200"
#define CONFIG_BOOTFILE		"uImage"

#define CFG_HUSH_PARSER 

#ifdef CFG_HUSH_PARSER
#define CONFIG_PREBOOT	"echo \'\n"					\
	"Type \"boot\"		for default way\n"			\
	"Type \"run flash\"	to boot from flash\n"			\
	"Type \"run disk\"		to boot from CF\n"		\
	"Type \"run nfs\"		to boot from NFS\n\'"

#define CONFIG_EXTRA_ENV_SETTINGS					\
	"mtdids=" MTDIDS_DEFAULT	"\0"				\
	"mtdparts=" MTDPARTS_DEFAULT	"\0"				\
	"partition=nor0,1\0"						\
	"autoload=no\0"							\
	"netretry=once\0"						\
	"verify=no\0"							\
	"kernel_start=FF800000\0"					\
	"kernel_size=200000\0"						\
	"cram_start=FFA00000\0"						\
	"cram_size=500000\0"						\
	"uboot_start=FFF00000\0"					\
	"uboot_size=40000\0"						\
	"env_start=FFF40000\0"						\
	"env_size=20000\0"						\
	"conf_start=FFF60000\0"						\
	"conf_size=A0000\0"						\
	"ubootfile=u-boot.bin\0"					\
	"initrdfile=ramImage\0"						\
	"cramfile=rom.img\0"						\
	"cramargs=setenv bootargs root=/dev/mtdblock1 ro\0"		\
	"diskargs=setenv bootargs root=/dev/hda1 ro\0"			\
	"nfsargs=setenv bootargs root=/dev/nfs "			\
		"ip=$ipaddr:$serverip:$gatewayip:$netmask::eth0: "	\
		"nfsroot=$nfsroot ro\0"					\
	"userargs=setenv bootargs $bootargs "				\
		"console=ttyPSC0,$baudrate $mtdparts\0"			\
	"ext2dev=0\0"							\
	"fatdev=0\0"							\
	"load_kernel_cram=fsload $bootfile\0"				\
	"load_kernel_ext2=ext2load ide $ext2dev 400000 $bootfile\0"	\
	"load_kernel_fat=fatload ide $fatdev 400000 $bootfile\0"	\
	"load_kernel_tftp=run checkipaddr&&tftp 400000 $bootfile\0"	\
	"load_kernel_nfs=run checknfsbase checkipaddr&&"		\
			"nfs 400000 $nfsbase$bootfile\0"		\
	"load_kernel_serial=echo \"Please send $bootfile\";"		\
			"loady 400000\0"				\
	"load_method=nfs\0"						\
	"load_kernel=run load_kernel_$load_method &&iminfo 400000\0"	\
	"load_initrd_cram=fsload $initrdfile\0"				\
	"load_initrd_ext2=ext2load ide $ext2dev 600000 $initrdfile\0"	\
	"load_initrd_fat=fatload ide $fatdev 600000 $initrdfile\0"	\
	"load_initrd_tftp=run checkipaddr&&tftp 600000 $initrdfile\0"	\
	"load_initrd_nfs=run checknfsbase checkipaddr&&"		\
			"nfs 600000 $nfsbase$initrdfile\0"		\
	"load_initrd_serial=echo \"Please send $initrdfile\";"		\
			"loady 600000\0"				\
	"load_initrd=run load_initrd_$load_method &&iminfo 600000\0"	\
	"load_cram_ext2=ext2load ide $ext2dev 400000 $cramfile\0"	\
	"load_cram_fat=fatload ide $fatdev 400000 $cramfile\0"		\
	"load_cram_tftp=run checkipaddr&&tftp 400000 $cramfile\0"	\
	"load_cram_nfs=run checknfsbase checkipaddr&&"			\
			"nfs 400000 $nfsbase$cramfile\0"		\
	"load_cram_serial=echo \"Please send $cramfile\";"		\
			"loady 400000\0"				\
	"load_cram=run load_cram_$load_method\0"			\
	"load_uboot_ext2=ext2load ide $ext2dev 400000 $ubootfile\0"	\
	"load_uboot_fat=fatload ide $fatdev 400000 $ubootfile\0"	\
	"load_uboot_tftp=run checkipaddr&&tftp 400000 $ubootfile\0"	\
	"load_uboot_nfs=run checknfsbase checkipaddr&&"			\
			"nfs 400000 $nfsbase$ubootfile\0"		\
	"load_uboot_serial=echo \"Please send $ubootfile\";"		\
			"loady 400000\0"				\
	"load_uboot=run load_uboot_$load_method\0"			\
	"flash=run cramargs userargs; bootm $kernel_start\0"		\
	"cram=if run load_kernel_cram; then run cramargs userargs;"	\
		"bootm;fi\0"						\
	"disk=ide reset&&if run load_kernel_ext2;then run diskargs "	\
		"userargs;bootm;fi\0"					\
	"nfs=if run load_kernel_nfs;then run nfsargs userargs &&"	\
		"bootm;fi\0"						\
	"initrd=if run load_kernel load_initrd; then "			\
		"run nfsargs userargs;bootm 400000 600000;"		\
		"fi\0"							\
	"uboot=if run load_uboot; then go 400100; fi\0"			\
	"checknfsbase=if test x$nfsbase = x;then "			\
		"echo \"*** ERROR: \'nfsbase\' not set\";test a = b;"	\
		"else test 1 = 1;fi\0"					\
	"checkipaddr=if test x$ipaddr = x;then dhcp;"			\
		"else test 1 = 1;fi\0"					\
	"init_uboot=protect off $uboot_start +$uboot_size;"		\
		"echo erasing uboot area;"				\
		"erase $uboot_start +$uboot_size\0"			\
	"init_cram=protect off $cram_start +$cram_size;"		\
		"echo erasing cram area;"				\
		"erase $cram_start +$cram_size\0"			\
	"init_kernel=protect off $kernel_start +$kernel_size;"		\
		"echo erasing kernel area;"				\
		"erase $kernel_start +$kernel_size\0"			\
	"init_env=protect off $env_start +$env_size;"			\
		"echo erasing env area;"				\
		"erase $env_start +$env_size\0"				\
	"init_conf=protect off $conf_start $conf_size;"			\
		"echo erasing conf area;"				\
		"erase $conf_start +$conf_size\0"			\
	"verify_uboot=if run load_uboot; then "				\
		"echo verifying image;"					\
		"cmp.b 400000 $uboot_start $filesize;"			\
		"else test a = b;fi\0"					\
	"verify_cram=if run load_cram; then "				\
		"echo verifying image;"					\
		"cmp.b 400000 $cram_start $filesize;"			\
		"else test a = b;fi\0"					\
	"verify_kernel=if run load_kernel; then "			\
		"echo verifying kernel;"				\
		"cmp.b 400000 $kernel_start $filesize;"			\
		"else test a = b;fi\0"					\
	"update_uboot=if run load_uboot&&itest $filesize <= $uboot_size;"\
 		"then run init_uboot;"					\
		"cp.b 400000 $uboot_start $filesize;"			\
		"run verify_uboot && reset;"				\
		"fi\0"							\
	"update_cram=if run load_cram&&itest $filesize <= $cram_size;"	\
		"then run init_cram;"					\
		"cp.b 400000 $cram_start $filesize;"			\
		"run verify_cram;"					\
		"fi\0"							\
	"update_kernel=if run load_kernel &&"				\
		"itest $filesize <= $kernel_size;"			\
		"then run init_kernel;"					\
		"cp.b 400000 $kernel_start $filesize;"			\
		"run verify_kernel;"					\
		"fi\0"							\
	""

#define CONFIG_BOOTCOMMAND	"run flash"
#endif

#define CONFIG_JFFS2_DEV		"nor0"
#define CONFIG_JFFS2_PART_OFFSET	0x0
#define CONFIG_JFFS2_PART_SIZE	(0xFFF00000 - 0xFF800000)
#define CONFIG_COMMANDS		(CONFIG_CMD_DFL | \
				 CFG_CMD_ASKENV | \
				 CFG_CMD_CACHE	| \
				 CFG_CMD_JFFS2	| \
				 CFG_CMD_DHCP	| \
				 CFG_CMD_PING	| \
				 CFG_CMD_MII	| \
				 CFG_CMD_PCI	| \
				 CFG_CMD_IDE	| \
				 CFG_CMD_DATE	| \
				 CFG_CMD_SNTP	| \
				/* CFG_CMD_REISER | */ \
				 CFG_CMD_EXT2	| \
				 CFG_CMD_FAT	| \
				 CFG_CMD_ELF	)


/*
 * PCI Mapping:
 * 0x40000000 - 0x4fffffff - PCI Memory
 * 0x50000000 - 0x50ffffff - PCI IO Space
 */
#define CONFIG_PCI		1
#define CONFIG_PCI_PNP		1
#define CFG_UDELAY_AFTER_PCI_RESET	1000
//#define CONFIG_PCI_SCAN_SHOW

#define CONFIG_PCI_MEM_BUS	0x40000000
#define CONFIG_PCI_MEM_PHYS	CONFIG_PCI_MEM_BUS
#define CONFIG_PCI_MEM_SIZE	0x10000000

#define CONFIG_PCI_IO_BUS	0x50000000
#define CONFIG_PCI_IO_PHYS	CONFIG_PCI_IO_BUS
#define CONFIG_PCI_IO_SIZE	0x01000000

#define CFG_XLB_PIPELINING	1
#define CFG_PCI_SNOOPING        1
#define CFG_STRENGTH_SETTINGS	1
#define CONFIG_PHY_LATECHECK    1


#define CONFIG_USE_ICACHE 1
#define CONFIG_USE_DCACHE 1
#define ADD_CMD_CACHE 		CFG_CMD_CACHE


#define CONFIG_EEPRO100		1
#define CFG_RX_ETH_BUFFER	8  /* use 8 rx buffer on eepro100  */
#define CONFIG_NS8382X		1

/* Partitions */
#define CONFIG_MAC_PARTITION
#define CONFIG_DOS_PARTITION
#define CONFIG_ISO_PARTITION



/* this must be included AFTER the definition of CONFIG_COMMANDS (if any) */
#include <cmd_confdefs.h>

#if (TEXT_BASE == 0xFF000000)		/* Boot low with 16 MB Flash */
#   define CFG_LOWBOOT	        1
#   define CFG_LOWBOOT16	1
#endif
#if (TEXT_BASE == 0xFF800000)		/* Boot low with  8 MB Flash */
#   define CFG_LOWBOOT	        1
#   define CFG_LOWBOOT08	1
#endif


/*
 * IPB Bus clocking configuration.
 */
#define CFG_IPBSPEED_133   		/* define for 133MHz speed */



/*
 * I2C configuration
 */
#define CONFIG_HARD_I2C		1	/* I2C with hardware support */
#define CFG_I2C_MODULE		2	/* Select I2C module #1 or #2 */

#define CFG_I2C_SPEED		100000 /* 100 kHz */
#define CFG_I2C_SLAVE		0x7F


/*
 * Flash configuration
 */
//#define CFG_FLASH_BASE		0xFF000000
//#define CFG_FLASH_SIZE		0x01000000
#define CFG_FLASH_BASE		0xFF800000
#define CFG_FLASH_SIZE		0x00800000
#define CFG_ENV_ADDR		(CFG_FLASH_BASE + 0x0740000)

//#if !defined(CFG_LOWBOOT)
//#define CFG_ENV_ADDR		(CFG_FLASH_BASE + 0x0740000 + 0x00800000)
//#else	/* CFG_LOWBOOT */
//#if defined(CFG_LOWBOOT08)
//#define CFG_ENV_ADDR		(CFG_FLASH_BASE + 0x00040000 + 0x00800000)
//#endif
//#if defined(CFG_LOWBOOT16)
//#define CFG_ENV_ADDR		(CFG_FLASH_BASE + 0x00040000)
//#endif
//#endif	/* CFG_LOWBOOT */


//#define CFG_MAX_FLASH_SECT	64	/* max num of sects on one chip */
#define CFG_FLASH_SECT_SIZE	0x20000	/* Sector Size */
//#define CFG_MAX_FLASH_SECT	256	/* max num of sects on one chip */
//#define CFG_FLASH_SECT_SIZE	0x10000	/* Sector Size */

#define CFG_FLASH_ERASE_TOUT	240000	/* Flash Erase Timeout (in ms)  */
#define CFG_FLASH_WRITE_TOUT	5000	/* Flash Write Timeout (in ms)  */
#undef CONFIG_FLASH_16BIT	/* Flash is 8-bit */
/* CFI flash settings */
#define CFG_FLASH_CFI
#define CFG_FLASH_CFI_DRIVER
#define CFG_MAX_FLASH_BANKS             (1)
#define CFG_MAX_FLASH_SECT              (256) /* actually 137 for 28F640 */
#define CFG_FLASH_CFI_WIDTH             FLASH_CFI_8BIT
#define CFG_FLASH_USE_BUFFER_WRITE      1


/*
 * IC DRAM configuration
 */
#define	CFG_DRAM_CHIP_SIZE	0x02000000
#define	CFG_DRAM_TOTAL		64*1024*1024

/*
 * Vendor DRAM configuration
 */
#define SDRAM_MODE	0x018D0000
#define SDRAM_EMODE	0x40090000
#define SDRAM_CONTROL	0x604f0f00
//#define SDRAM_CONTROL	0x704f0f00
#define SDRAM_CONFIG1	0x73722930
#define SDRAM_CONFIG2	0x47770000
#define SDRAM_TAPDELAY	0x18000000

/*
 * Environment settings
 */
#define CFG_ENV_IS_IN_FLASH	1
#define CFG_ENV_SIZE		0x20000
#define CFG_ENV_SECT_SIZE	0x20000
#define CONFIG_ENV_OVERWRITE	1
#define CFG_ENV_SAVESIZE	1

/*
 * Memory map
 */
#define CFG_MBAR		0xF0000000
#define CFG_SDRAM_BASE		0x00000000
#define CFG_DEFAULT_MBAR	0x80000000

/*
 * We initialize dram early
 */
//#define CONFIG_BOARD_EARLY_DRAMINIT 1
//#define CFG_RCR_DELAY_SETTINGS      1 /* required for all MPC5200B parts for timings */

/* Use SRAM until RAM will be available */
#define CFG_INIT_RAM_ADDR	MPC5XXX_SRAM
#define CFG_INIT_RAM_END	MPC5XXX_SRAM_SIZE	/* End of used area in DPRAM */


#define CFG_GBL_DATA_SIZE	128	/* size in bytes reserved for initial data */
#define CFG_GBL_DATA_OFFSET	(CFG_INIT_RAM_END - CFG_GBL_DATA_SIZE)
#define CFG_INIT_SP_OFFSET	CFG_GBL_DATA_OFFSET

#define CFG_MONITOR_BASE    TEXT_BASE
#if (CFG_MONITOR_BASE < CFG_FLASH_BASE)
#   define CFG_RAMBOOT		1
#endif

#define CFG_MONITOR_LEN		(256 << 10)	/* Reserve 256 kB for Monitor	*/
#define CFG_MALLOC_LEN		(128 << 10)	/* Reserve 128 kB for malloc()	*/
#define CFG_BOOTMAPSZ		(8 << 20)	/* Initial Memory map for Linux */


/*
 * GPIO configuration
 */
#define CFG_GPS_PORT_CONFIG	0x90000004

/*
 * Miscellaneous configurable options
 */
#define CFG_LONGHELP			/* undef to save memory	    */
#define CFG_PROMPT		"# "	/* Monitor Command Prompt   */
#define CFG_PROMPT_HUSH_PS2  "> "
#define CONFIG_AUTO_COMPLETE    1
#define CFG_CBSIZE		512	/* Console I/O Buffer Size  */
#define CFG_PBSIZE (CFG_CBSIZE+sizeof(CFG_PROMPT)+16)	/* Print Buffer Size */
#define CFG_MAXARGS		16	/* max number of command args	*/
#define CFG_BARGSIZE		CFG_CBSIZE	/* Boot Argument Buffer Size */

#define CFG_MEMTEST_START	0x00100000	/* memtest works on */
#define CFG_MEMTEST_END		0x00f00000	/* 1 ... 15 MB in DRAM	*/

#define CFG_LOAD_ADDR		0x400000	/* default load address */

#define CFG_HZ			1000	/* decrementer freq: 1 ms ticks */

/*
 * Various low-level settings
 */
#define CFG_HID0_INIT		HID0_ICE | HID0_ICFI
#define CFG_HID0_FINAL		HID0_ICE

#define CFG_BOOTCS_START	CFG_FLASH_BASE
#define CFG_BOOTCS_SIZE		CFG_FLASH_SIZE
#define CFG_BOOTCS_CFG		0x00047800
#define CFG_CS0_START		CFG_FLASH_BASE
#define CFG_CS0_SIZE		CFG_FLASH_SIZE
#define CFG_CS1_START		CFG_FLASH_BASE-CFG_FLASH_SIZE
#define CFG_CS1_SIZE		CFG_FLASH_SIZE
#define CFG_CS1_CFG			0x00047800

#define CFG_CS_BURST		0x00000000
#define CFG_CS_DEADCYCLE	0x33333333

#define CFG_RESET_ADDRESS	0xff000000

/*-----------------------------------------------------------------------
 * USB stuff
 *-----------------------------------------------------------------------
 */
#define CONFIG_USB_CLOCK	0x0001BBBB
#define CONFIG_USB_CONFIG	0x00001000  


/*-----------------------------------------------------------------------
 * PCI stuff
 */
#define CONFIG_NET_MULTI
#define CFG_RX_ETH_BUFFER	8	 /* use 8 rx buffer */
#define CONFIG_RTL8169
#define CONFIG_IFNIC_PCI


#define CONFIG_SKIP_IDE_ON_STARTUP
#define CONFIG_ATAPI		1
#define CFG_IDE_MAXBUS		1
#define CFG_IDE_MAXDEVICE	(CFG_IDE_MAXBUS*2)
#define CFG_ATA_BASE_ADDR	0x00000000
#define CFG_ATA_IDE0_OFFSET	0
#define CFG_ATA_DATA_OFFSET	0xC0
#define	CFG_ATA_REG_OFFSET	CFG_ATA_DATA_OFFSET
#define CFG_ATA_ALT_OFFSET	0xE0
#define CFG_ATA_STRIDE		4
#define CONFIG_IDE_PREINIT
#define CONFIG_NO_MPC5200_IDE

#endif /* __CONFIG_H */
