/*
 * (C) Copyright 2003-2005
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * (C) Copyright 2004
 * Metrowerks, Author: Bernhard Kuhn <bkuhn@metrowerks.com> [BK]
 *
 * BK: added CFG_ENV_SAVESIZE option
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 *
 * Midified 2007.4.19  Media Lab., Inc  <linux@mlb.co.jp>
 *   Changed for TANBAC TB0328
 * Midified 2007.06.01  Forks Inc  <info@yaya.forks.co.jp>
 *   added for CONFIG_ZERO_BOOTDELAY_CHECK define.
 *   added for CONFIG_TB0XXX_IDE define. (allow ide_maxbus enviroment)
 */

#ifndef __CONFIG_H
#define __CONFIG_H

/*
 * High Level Configuration Options
 * (easy to change)
 */

#define CONFIG_MPC5200			/* MPC5200 CPU */
#define CONFIG_MPC5xxx		1	/* This is an MPC5xxx CPU */
#define CONFIG_ICECUBE		1	/* ... on IceCube board */
#define CONFIG_TB0XXX_IDE               /* allow ide_maxbus environment */

#define CFG_MPC5XXX_CLKIN	33000000 /* ... running at 33.000000MHz */

#define BOOTFLAG_COLD		0x01	/* Normal Power-On: Boot from FLASH  */
#define BOOTFLAG_WARM		0x02	/* Software reboot	     */

#define CFG_CACHELINE_SIZE	32	/* For MPC5xxx CPUs */
#if (CONFIG_COMMANDS & CFG_CMD_KGDB)
#  define CFG_CACHELINE_SHIFT	5	/* log base 2 of the above value */
#endif

#define CONFIG_BOOTDELAY	5	/* autoboot after 5 seconds	*/
#define CONFIG_ZERO_BOOTDELAY_CHECK     /* check for keypress on bootdelay==0 */

/*
 * Serial console configuration
 */
#define CONFIG_PSC_CONSOLE	1	/* console is on PSC1 */
#define CONFIG_BAUDRATE		115200	/* ... at 115200 bps */
#define CFG_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200, 230400 }

#define CONFIG_TIMESTAMP		/* Print image info with timestamp */

#undef	CONFIG_BOOTARGS

#define CFG_HUSH_PARSER 

#ifdef CFG_HUSH_PARSER
/*
#define CONFIG_PREBOOT	"echo \'\n"					\
	"Type \"boot\"		for default way\n"			\
	"Type \"run disk\"		to boot from CF\n"		\
	"Type \"run nfs\"		to boot from NFS\n\'"
*/
	
#define CONFIG_EXTRA_ENV_SETTINGS					\
	"bootargs=root=/dev/mtdblock1 ro console=ttyPSS0,$baudrate\0"	\
	"autoload=no\0"							\
	"netretry=once\0"						\
	"verify=no\0"							\
	"uboot_start=FFF00000\0"					\
	"uboot_end=FFF3FFFF\0"						\
	"uboot_size=40000\0"					\
	"env_start=FFF40000\0"						\
	"env_end=FFF5FFFF\0"						\
	"cram_start=FFA0000\0"						\
	"cram_size=500000\0"						\
	"bootfile=uImage\0"						\
	"ubootfile=u-boot.bin\0"					\
	"initrdfile=ramImage\0"						\
	"cramfile=rom.img\0"						\
	"cramargs=setenv bootargs root=/dev/mtdblock1 ro\0"		\
	"diskargs=setenv bootargs root=/dev/hda1 ro\0"			\
	"nfsargs=setenv bootargs root=/dev/nfs ip=:::::eth0:dhcp "	\
		"nfsroot=$(nfsroot) ro\0"				\
	"usbargs=setenv bootargs $bootargs rootdev=$rootdev "	\
		"devorder=$devorder fstype=$fstype timeout=$timeout\0"\
	"userargs=setenv bootargs $bootargs "				\
		"console=tty console=ttyPSC0,$baudrate \0"		\
	"nfsbase=192.168.3.91:/usr/src/mpc5200/\0"			\
	"nfsroot=192.168.3.91:/usr/src/mpc5200/rom\0"			\
	"ext2dev=0\0"							\
	"fatdev=0\0"							\
	"load_kernel_ext2=ext2load ide $ext2dev 400000 $bootfile\0"	\
	"load_kernel_nfs=run checknfsbase checkipaddr&&"		\
		"nfs 400000 ${nfsbase}${bootfile}\0"			\
	"disk=if run load_kernel_ext2;then run diskargs userargs;"	\
		"bootm;fi\0"						\
	"nfs=if run load_kernel_nfs;then run nfsargs userargs &&"	\
		"bootm;fi\0"						\
	"checknfsbase=if test x${nfsbase} = x;then "			\
		"echo \"*** ERROR: \'nfsbase\' not set\";test a = b;"	\
		"else test 1 = 1;fi\0"					\
	"checkipaddr=if test x${ipaddr} = x;then dhcp;"			\
		"else test 1 = 1;fi\0"					\
	"bootorder=disk nfs\0"					\
	"tryboot=for i in $bootorder; do run $i; done\0"		\
	""

#define CONFIG_BOOTCOMMAND	"run tryboot"
#endif

/**********
#define CONFIG_EXTRA_ENV_SETTINGS \
	"skipnetcheck=y\0"						\
	"skippcicheck=y\0"						\
	"skipidecheck=y\0"						\
	"verify=n\0"							\
	"netdev=eth0\0"							\
*/

#undef CONFIG_JFFS2_CMDLINE
#define CONFIG_JFFS2_DEV	"nor0"
#define CONFIG_JFFS2_PART_OFFSET	0x60000
#define CONFIG_JFFS2_PART_SIZE	(0xC0000000 - 0xBFC60000)
#define CONFIG_COMMANDS		(CONFIG_CMD_DFL | \
				 CFG_CMD_ASKENV | \
				 CFG_CMD_JFFS2	| \
				 CFG_CMD_DHCP	| \
				 CFG_CMD_PING	| \
				 CFG_CMD_PCI	| \
				 CFG_CMD_IDE	| \
				/* CFG_CMD_REISER | */ \
				 CFG_CMD_EXT2	| \
				 CFG_CMD_FAT	| \
				 CFG_CMD_ELF	)


#ifdef CONFIG_MPC5200	/* MPC5100 PCI is not supported yet. */
/*
 * PCI Mapping:
 * 0x40000000 - 0x4fffffff - PCI Memory
 * 0x50000000 - 0x50ffffff - PCI IO Space
 */
#if 1
#define CONFIG_PCI		1
#define CONFIG_PCI_PNP		1
//#define CONFIG_PCI_SCAN_SHOW

#define CONFIG_PCI_MEM_BUS	0x40000000
#define CONFIG_PCI_MEM_PHYS	CONFIG_PCI_MEM_BUS
#define CONFIG_PCI_MEM_SIZE	0x10000000

#define CONFIG_PCI_IO_BUS	0x50000000
#define CONFIG_PCI_IO_PHYS	CONFIG_PCI_IO_BUS
#define CONFIG_PCI_IO_SIZE	0x01000000
#endif 

#define CFG_XLB_PIPELINING	1
#define CFG_PCI_SNOOPING        1
#define CFG_STRENGTH_SETTINGS	1
#define CONFIG_PHY_LATECHECK    1


#if 1
#define CONFIG_USE_ICACHE 1
#define CONFIG_USE_DCACHE 1
#define ADD_CMD_CACHE 		CFG_CMD_CACHE
#endif


#if 1
#define CONFIG_EEPRO100		1
#define CFG_RX_ETH_BUFFER	8  /* use 8 rx buffer on eepro100  */
#define CONFIG_NS8382X		1

#define ADD_PCI_CMD 		CFG_CMD_PCI
#endif
#define CONFIG_MII              1

#else	/* MPC5100 */

#define ADD_PCI_CMD		0  /* no CFG_CMD_PCI */

#endif

/* Partitions */
#define CONFIG_MAC_PARTITION
#define CONFIG_DOS_PARTITION
#define CONFIG_ISO_PARTITION



/* this must be included AFTER the definition of CONFIG_COMMANDS (if any) */
#include <cmd_confdefs.h>

#if (TEXT_BASE == 0xFF000000)		/* Boot low with 16 MB Flash */
#   define CFG_LOWBOOT	        1
#   define CFG_LOWBOOT16	1
#endif
#if (TEXT_BASE == 0xFF800000)		/* Boot low with  8 MB Flash */
#   define CFG_LOWBOOT	        1
#   define CFG_LOWBOOT08	1
#endif




#if defined(CONFIG_MPC5200)
/*
 * IPB Bus clocking configuration.
 */
#define CFG_IPBSPEED_133   		/* define for 133MHz speed */
#endif



/*
 * I2C configuration
 */
#define CONFIG_HARD_I2C		1	/* I2C with hardware support */
#define CFG_I2C_MODULE		2	/* Select I2C module #1 or #2 */

#define CFG_I2C_SPEED		100000 /* 100 kHz */
#define CFG_I2C_SLAVE		0x7F


/*
 * Flash configuration
 */
//#define CFG_FLASH_BASE		0xFF000000
//#define CFG_FLASH_SIZE		0x01000000
#define CFG_FLASH_BASE		0xFF800000
#define CFG_FLASH_SIZE		0x00800000
#define CFG_ENV_ADDR		(CFG_FLASH_BASE + 0x0740000)

//#if !defined(CFG_LOWBOOT)
//#define CFG_ENV_ADDR		(CFG_FLASH_BASE + 0x0740000 + 0x00800000)
//#else	/* CFG_LOWBOOT */
//#if defined(CFG_LOWBOOT08)
//#define CFG_ENV_ADDR		(CFG_FLASH_BASE + 0x00040000 + 0x00800000)
//#endif
//#if defined(CFG_LOWBOOT16)
//#define CFG_ENV_ADDR		(CFG_FLASH_BASE + 0x00040000)
//#endif
//#endif	/* CFG_LOWBOOT */


//#define CFG_MAX_FLASH_SECT	64	/* max num of sects on one chip */
#define CFG_FLASH_SECT_SIZE	0x20000	/* Sector Size */
//#define CFG_MAX_FLASH_SECT	256	/* max num of sects on one chip */
//#define CFG_FLASH_SECT_SIZE	0x10000	/* Sector Size */

#define CFG_FLASH_ERASE_TOUT	240000	/* Flash Erase Timeout (in ms)  */
#define CFG_FLASH_WRITE_TOUT	5000	/* Flash Write Timeout (in ms)  */
#undef CONFIG_FLASH_16BIT	/* Flash is 8-bit */
/* CFI flash settings */
#define CFG_FLASH_CFI
#define CFG_FLASH_CFI_DRIVER
#define CFG_MAX_FLASH_BANKS             (1)
#define CFG_MAX_FLASH_SECT              (256) /* actually 137 for 28F640 */
#define CFG_FLASH_CFI_WIDTH             FLASH_CFI_8BIT
#define CFG_FLASH_USE_BUFFER_WRITE      1


/*
 * IC DRAM configuration
 */
#define	CFG_DRAM_CHIP_SIZE	0x02000000
#define	CFG_DRAM_TOTAL		64*1024*1024

/*
 * Vendor DRAM configuration
 */
#define SDRAM_MODE	0x018D0000
#define SDRAM_EMODE	0x40090000
#define SDRAM_CONTROL	0x604f0f00
//#define SDRAM_CONTROL	0x704f0f00
#define SDRAM_CONFIG1	0x73722930
#define SDRAM_CONFIG2	0x47770000
#define SDRAM_TAPDELAY	0x18000000

/*
 * Environment settings
 */
#define CFG_ENV_IS_IN_FLASH	1
#define CFG_ENV_SIZE		0x20000
#define CFG_ENV_SECT_SIZE	0x20000
#define CONFIG_ENV_OVERWRITE	1
#define CFG_ENV_SAVESIZE	1

/*
 * Memory map
 */
#define CFG_MBAR		0xF0000000
#define CFG_SDRAM_BASE		0x00000000
#define CFG_DEFAULT_MBAR	0x80000000

/*
 * We initialize dram early
 */
//#define CONFIG_BOARD_EARLY_DRAMINIT 1
//#define CFG_RCR_DELAY_SETTINGS      1 /* required for all MPC5200B parts for timings */

/* Use SRAM until RAM will be available */
#define CFG_INIT_RAM_ADDR	MPC5XXX_SRAM
#define CFG_INIT_RAM_END	MPC5XXX_SRAM_SIZE	/* End of used area in DPRAM */


#define CFG_GBL_DATA_SIZE	128	/* size in bytes reserved for initial data */
#define CFG_GBL_DATA_OFFSET	(CFG_INIT_RAM_END - CFG_GBL_DATA_SIZE)
#define CFG_INIT_SP_OFFSET	CFG_GBL_DATA_OFFSET

#define CFG_MONITOR_BASE    TEXT_BASE
#if (CFG_MONITOR_BASE < CFG_FLASH_BASE)
#   define CFG_RAMBOOT		1
#endif

#define CFG_MONITOR_LEN		(192 << 10)	/* Reserve 192 kB for Monitor	*/
#define CFG_MALLOC_LEN		(128 << 10)	/* Reserve 128 kB for malloc()	*/
#define CFG_BOOTMAPSZ		(8 << 20)	/* Initial Memory map for Linux */


/*
 * GPIO configuration
 */
#ifdef CONFIG_MPC5200_DDR
#define CFG_GPS_PORT_CONFIG	0x90000004
#else
#define CFG_GPS_PORT_CONFIG	0x10000004
#endif

/*
 * Miscellaneous configurable options
 */
#define CFG_LONGHELP			/* undef to save memory	    */
#define CFG_PROMPT		"# "	/* Monitor Command Prompt   */
#define CFG_PROMPT_HUSH_PS2  "> "
#define CONFIG_AUTO_COMPLETE    1
#define CFG_CBSIZE		512	/* Console I/O Buffer Size  */
#define CFG_PBSIZE (CFG_CBSIZE+sizeof(CFG_PROMPT)+16)	/* Print Buffer Size */
#define CFG_MAXARGS		16	/* max number of command args	*/
#define CFG_BARGSIZE		CFG_CBSIZE	/* Boot Argument Buffer Size */

#define CFG_MEMTEST_START	0x00100000	/* memtest works on */
#define CFG_MEMTEST_END		0x00f00000	/* 1 ... 15 MB in DRAM	*/

#define CFG_LOAD_ADDR		0x100000	/* default load address */

#define CFG_HZ			1000	/* decrementer freq: 1 ms ticks */

/*
 * Various low-level settings
 */
#if defined(CONFIG_MPC5200)
#define CFG_HID0_INIT		HID0_ICE | HID0_ICFI
#define CFG_HID0_FINAL		HID0_ICE
#else
#define CFG_HID0_INIT		0
#define CFG_HID0_FINAL		0
#endif

#ifdef CONFIG_MPC5200_DDR

//#define CFG_BOOTCS_START	(CFG_CS1_START + CFG_CS1_SIZE)
//#define CFG_BOOTCS_SIZE		0x00800000
//#define CFG_BOOTCS_CFG		0x00047801
//#define CFG_CS1_START		CFG_FLASH_BASE
//#define CFG_CS1_SIZE		0x00800000
//#define CFG_CS1_CFG		0x00047800
#define CFG_BOOTCS_START	CFG_FLASH_BASE
#define CFG_BOOTCS_SIZE		CFG_FLASH_SIZE
#define CFG_BOOTCS_CFG		0x00047800
#define CFG_CS0_START		CFG_FLASH_BASE
#define CFG_CS0_SIZE		CFG_FLASH_SIZE
#define CFG_CS1_START		CFG_FLASH_BASE-CFG_FLASH_SIZE
#define CFG_CS1_SIZE		CFG_FLASH_SIZE
#define CFG_CS1_CFG			0x00047800

#else /* !CONFIG_MPC5200_DDR */

#define CFG_BOOTCS_START	CFG_FLASH_BASE
#define CFG_BOOTCS_SIZE		CFG_FLASH_SIZE
#define CFG_BOOTCS_CFG		0x00047801
#define CFG_CS0_START		CFG_FLASH_BASE
#define CFG_CS0_SIZE		CFG_FLASH_SIZE

#endif /* CONFIG_MPC5200_DDR */

#define CFG_CS_BURST		0x00000000
#define CFG_CS_DEADCYCLE	0x33333333

#define CFG_RESET_ADDRESS	0xff000000

/*-----------------------------------------------------------------------
 * USB stuff
 *-----------------------------------------------------------------------
 */
#define CONFIG_USB_CLOCK	0x0001BBBB
#define CONFIG_USB_CONFIG	0x00001000  

/*
 * Ethernet configuration
 */
#define CONFIG_MPC5xxx_FEC      1
#define CONFIG_PHY_ADDR         0x01


/*-----------------------------------------------------------------------
 * PCI stuff
 */
//#define CONFIG_PCI
//#define CONFIG_PCI_PNP
#define CONFIG_NET_MULTI
#define CFG_PCISPEED_66

/*
 * IDE/ATA stuff Supports IDE harddisk
 */

#define CONFIG_IDE_RESET        /* reset for ide supported  */
#define CONFIG_IDE_PREINIT

#define CONFIG_ATAPI		1
#define CFG_IDE_MAXBUS		1
#define CFG_IDE_MAXDEVICE	2
#define CFG_ATA_BASE_ADDR	MPC5XXX_ATA
#define CFG_ATA_IDE0_OFFSET	0x0
#define CFG_ATA_DATA_OFFSET	(0x0060)
#define	CFG_ATA_REG_OFFSET	(CFG_ATA_DATA_OFFSET)
#define CFG_ATA_ALT_OFFSET	(0x005C)
#define CFG_ATA_STRIDE          4

#endif /* __CONFIG_H */
